glibmm 2.56.0

Public Types | Public Member Functions | Static Public Member Functions | List of all members
Glib::Variant< std::tuple< Types... > > Class Template Reference
Variant Data Types

Specialization of Variant containing a tuple. More...

`#include <glibmm/variant.h>`

Inheritance diagram for Glib::Variant< std::tuple< Types... > >:
[legend]

## Public Types
using | CppContainerType = std::tuple< Types... >
Public Types inherited from Glib::VariantContainerBase
using | CType = GVariant*
using | CppType = VariantContainerBase
Public Types inherited from Glib::VariantBase
using | BoolExpr = const void*
| This typedef is just to make it more obvious that our operator const void* should be used like operator bool(). More...

## Public Member Functions
| Variant ()
| Default constructor. More...
| Variant (GVariant* castitem, bool take_a_reference=false)
| GVariant constructor. More...
template<class T >
T | get_child (gsize index) const
| Gets a specific element from the tuple. More...
template<class T >
Variant< T > | get_child_variant (gsize index) const
std::tuple< Types... > | get () const
| Gets the tuple of the Variant. More...
VariantIter | get_iter () const
| Gets a VariantIter of the Variant. More...
Public Member Functions inherited from Glib::VariantContainerBase
| VariantContainerBase ()
| Default constructor. More...
| VariantContainerBase (GVariant* castitem, bool take_a_reference=false)
| GVariant constructor. More...
gsize | get_n_children () const
| Determines the number of children in a container Variant instance. More...
void | get_child (VariantBase& child, gsize index=0) const
| Reads a child item out of this instance. More...
VariantBase | get_child (gsize index=0)
| Reads a child item out of a container Variant instance. More...
bool | get_maybe (VariantBase& maybe) const
| If this is a maybe-typed instance, try to extract its value. More...
Public Member Functions inherited from Glib::VariantBase
| VariantBase ()
| Constructs an invalid object. More...
| VariantBase (GVariant* castitem, bool make_a_copy=false)
| VariantBase (const VariantBase& src)
VariantBase& | operator= (const VariantBase& src)
| VariantBase (VariantBase&& other) noexcept
VariantBase& | operator= (VariantBase&& other) noexcept
| ~VariantBase () noexcept
void | swap (VariantBase& other) noexcept
GVariant* | gobj ()
const GVariant* | gobj () const
GVariant* | gobj_copy () const
| Provides access to the underlying C instance. The caller is responsible for freeing it. Use when directly setting fields in structs. More...
| operator BoolExpr () const
| Test whether the Variant has an underlying instance. More...
| operator bool () const
| Test whether the Variant has an underlying instance. More...
void | init (const GVariant* cobject, bool take_a_reference=false)
| Replace the underlying GVariant. More...
VariantType | get_type () const
| Determines the type of value. More...
std::string | get_type_string () const
| Returns the type string of value. More...
bool | is_floating () const
| Checks whether value has a floating reference count. More...
bool | is_of_type (const VariantType& type) const
| Checks if a value has a type matching the provided type. More...
bool | is_container () const
| Checks if value is a container. More...
GVariantClass | classify () const
| Classifies value according to its top-level type. More...
gsize | get_size () const
| Determines the number of bytes that would be required to store value with g_variant_store(). More...
gconstpointer | get_data ()
| Returns a pointer to the serialised form of a Variant instance. More...
gconstpointer | get_data () const
| Returns a pointer to the serialised form of a Variant instance. More...
Glib::RefPtr< const Glib::Bytes > | get_data_as_bytes () const
| Returns a pointer to the serialised form of a Variant instance. More...
void | store (gpointer data) const
| Stores the serialised form of value at data. More...
Glib::ustring | print (bool type_annotate=false) const
| Pretty-prints value in the format understood by g_variant_parse(). More...
guint | hash () const
| Generates a hash value for a Variant instance. More...
bool | equal (const VariantBase& other) const
| Checks if *this and other have the same type and value. More...
void | get_normal_form (VariantBase& result) const
| Gets a VariantBase instance that has the same value as this variant and is trusted to be in normal form. More...
bool | is_normal_form () const
| Checks if value is in normal form. More...
void | byteswap (VariantBase& result) const
| Performs a byteswapping operation on the contents of this variant. More...
bool | check_format_string (const std::string& format_string, bool copy_only=false) const
| Checks if calling g_variant_get() with format_string on value would be valid from a type-compatibility standpoint. More...
template<>
VariantContainerBase | cast_dynamic (const VariantBase& v)

## Static Public Member Functions
static Variant< std::tuple< Types... > > | create (const std::tuple< Types... >& data)
| Creates a new Variant containing a tuple. More...
static const VariantType& | variant_type ()
| Gets the VariantType. More...
Static Public Member Functions inherited from Glib::VariantContainerBase
static VariantContainerBase | create_tuple (const std::vector< VariantBase >& children)
| Create a tuple variant from a vector of its variant children. More...
static VariantContainerBase | create_tuple (const VariantBase& child)
| Create a tuple variant with a single variant child. More...
static VariantContainerBase | create_maybe (const VariantType& child_type, const VariantBase& child=VariantBase())
| Depending on if child is `nullptr`, either wraps child inside of a maybe container or creates a Nothing instance for the given type. More...
Static Public Member Functions inherited from Glib::VariantBase
template<class V_CastTo >
static V_CastTo | cast_dynamic (const VariantBase& v)
| Cast to a specific variant type. More...

## Additional Inherited Members
Protected Attributes inherited from Glib::VariantBase
GVariant* | gobject_
Related Functions inherited from Glib::VariantBase
void | swap (VariantBase& lhs, VariantBase& rhs) noexcept
Glib::VariantBase | wrap (GVariant* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

### template<class... Types>
class Glib::Variant< std::tuple< Types... > >

Specialization of Variant containing a tuple.

Since glibmm 2.54:

## Member Typedef Documentation

## ◆ CppContainerType

template <class... Types>

using Glib::Variant< std::tuple< Types... > >::CppContainerType = std::tuple<Types...>

## Constructor & Destructor Documentation

## ◆ Variant() [1/2]

template <class... Types>

Glib::Variant< std::tuple< Types... > >::Variant | ( |  | ) |
| inline

Default constructor.

## ◆ Variant() [2/2]

template <class... Types>

Glib::Variant< std::tuple< Types... > >::Variant | ( | GVariant< std::tuple< Types... > > * | castitem,
|  | bool | take_a_reference = `false`
| ) |  |
| inline explicit

GVariant constructor.

Parameters

  castitem | The GVariant to wrap.
  take_a_reference | Whether to take an extra reference of the GVariant or not (not taking one could destroy the GVariant with the wrapper).

## Member Function Documentation

## ◆ create()

template <class... Types>

Variant< std::tuple< Types... > > Glib::Variant< std::tuple< Types... > >::create | ( | const std::tuple< Types... > & | data | ) |
| static

Creates a new Variant containing a tuple.

Parameters

  data | The tuple to use for creation.

Returns
  The new Variant holding a tuple.

Since glibmm 2.54:

## ◆ get()

template <class... Types>

std::tuple< Types... > Glib::Variant< std::tuple< Types... > >::get | ( |  | ) | const

Gets the tuple of the Variant.

Returns
  The tuple.

Since glibmm 2.54:

## ◆ get_child()

template <class... Types>
template <class T >

T Glib::Variant< std::tuple< Types... > >::get_child | ( | gsize | index | ) | const

Gets a specific element from the tuple.

It is an error if index is greater than or equal to the number of elements in the tuple. See VariantContainerBase::get_n_children().

Parameters

  index | The index of the element.

Returns
  The tuple element at index index.

Exceptions

  std::out_of_range |

Since glibmm 2.54:

## ◆ get_child_variant()

template <class... Types>
template <class T >

Variant< T > Glib::Variant< std::tuple< Types... > >::get_child_variant | ( | gsize | index | ) | const

## ◆ get_iter()

template <class... Types>

VariantIter Glib::Variant< std::tuple< Types... > >::get_iter | ( |  | ) | const

Gets a VariantIter of the Variant.

Returns
  The VariantIter.

Since glibmm 2.54:

## ◆ variant_type()

template <class... Types>

const VariantType& Glib::Variant< std::tuple< Types... > >::variant_type | ( |  | ) |
| static

Gets the VariantType.

Returns
  The VariantType.

Since glibmm 2.54: